<?php
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelSetorProducaoKDSReportHandler extends AReportHandler {
	const dataSourceName = 'orm00021_relSetorProducaoKDSDataExporter';
	
	public function buildNewRequest($request, Response $response) {
		$conditions = $this->relService->getParamsAsArray($request);
		
		unset($conditions['NMFILIAL']);
		unset($conditions['NMPRODUTO']);
		
		$likeableConditions = $this->relService->getLikeConditions($request);
		
		foreach ($likeableConditions as $condition) {
			if(array_key_exists($condition['columnName'], $conditions)) {
				 unset($conditions[$condition['columnName']]);
			}
		}
		
		$conditions = $this->relService->addParams($conditions, 'CDFILIAL');
		$conditions = $this->relService->addParams($conditions, 'CDSETOR');
		$conditions = $this->relService->addParams($conditions, 'CDPRODUTO');
		$this->relService->setIntervalAsDTINIandDTFIM($conditions, 'DTENTRVENDA', 'DTINIT', 'DTFIM');

		$newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::dataSourceName, $conditions); 
		
		foreach ($likeableConditions as $condition) {
			$newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
		}
		
        return [$newRequest, $response];
	}
}